Randy Dunlap | dcecc6c | 2007-07-15 23:41:15 -0700 | [diff] [blame] | 1 | #!/bin/sh |
| 2 | # Disassemble the Code: line in Linux oopses |
| 3 | # usage: decodecode < oops.file |
| 4 | # |
| 5 | # options: set env. variable AFLAGS=options to pass options to "as"; |
| 6 | # e.g., to decode an i386 oops on an x86_64 system, use: |
| 7 | # AFLAGS=--32 decodecode < 386.oops |
| 8 | |
Randy Dunlap | fa220d8 | 2008-01-14 15:18:31 -0800 | [diff] [blame] | 9 | cleanup() { |
Rabin Vincent | 5358db0 | 2010-01-05 20:27:58 +0530 | [diff] [blame] | 10 | rm -f $T $T.s $T.o $T.oo $T.aa $T.dis |
Randy Dunlap | fa220d8 | 2008-01-14 15:18:31 -0800 | [diff] [blame] | 11 | exit 1 |
| 12 | } |
| 13 | |
| 14 | die() { |
| 15 | echo "$@" |
| 16 | exit 1 |
| 17 | } |
| 18 | |
| 19 | trap cleanup EXIT |
| 20 | |
| 21 | T=`mktemp` || die "cannot create temp file" |
Randy Dunlap | dcecc6c | 2007-07-15 23:41:15 -0700 | [diff] [blame] | 22 | code= |
| 23 | |
| 24 | while read i ; do |
| 25 | |
| 26 | case "$i" in |
| 27 | *Code:*) |
| 28 | code=$i |
| 29 | ;; |
| 30 | esac |
| 31 | |
| 32 | done |
| 33 | |
| 34 | if [ -z "$code" ]; then |
Randy Dunlap | fa220d8 | 2008-01-14 15:18:31 -0800 | [diff] [blame] | 35 | rm $T |
Randy Dunlap | dcecc6c | 2007-07-15 23:41:15 -0700 | [diff] [blame] | 36 | exit |
| 37 | fi |
| 38 | |
| 39 | echo $code |
| 40 | code=`echo $code | sed -e 's/.*Code: //'` |
| 41 | |
Rabin Vincent | 5358db0 | 2010-01-05 20:27:58 +0530 | [diff] [blame] | 42 | width=`expr index "$code" ' '` |
Rabin Vincent | b396aa0 | 2010-06-03 22:48:12 +0530 | [diff] [blame] | 43 | width=$((($width-1)/2)) |
Rabin Vincent | 5358db0 | 2010-01-05 20:27:58 +0530 | [diff] [blame] | 44 | case $width in |
| 45 | 1) type=byte ;; |
| 46 | 2) type=2byte ;; |
| 47 | 4) type=4byte ;; |
| 48 | esac |
| 49 | |
| 50 | disas() { |
Rabin Vincent | b396aa0 | 2010-06-03 22:48:12 +0530 | [diff] [blame] | 51 | ${CROSS_COMPILE}as $AFLAGS -o $1.o $1.s > /dev/null 2>&1 |
Rabin Vincent | 5358db0 | 2010-01-05 20:27:58 +0530 | [diff] [blame] | 52 | |
Rabin Vincent | b396aa0 | 2010-06-03 22:48:12 +0530 | [diff] [blame] | 53 | if [ "$ARCH" = "arm" ]; then |
| 54 | if [ $width -eq 2 ]; then |
Rabin Vincent | 5358db0 | 2010-01-05 20:27:58 +0530 | [diff] [blame] | 55 | OBJDUMPFLAGS="-M force-thumb" |
| 56 | fi |
| 57 | |
| 58 | ${CROSS_COMPILE}strip $1.o |
| 59 | fi |
| 60 | |
| 61 | ${CROSS_COMPILE}objdump $OBJDUMPFLAGS -S $1.o | \ |
Rabin Vincent | b396aa0 | 2010-06-03 22:48:12 +0530 | [diff] [blame] | 62 | grep -v "/tmp\|Disassembly\|\.text\|^$" > $1.dis 2>&1 |
Rabin Vincent | 5358db0 | 2010-01-05 20:27:58 +0530 | [diff] [blame] | 63 | } |
| 64 | |
Randy Dunlap | dcecc6c | 2007-07-15 23:41:15 -0700 | [diff] [blame] | 65 | marker=`expr index "$code" "\<"` |
| 66 | if [ $marker -eq 0 ]; then |
| 67 | marker=`expr index "$code" "\("` |
| 68 | fi |
| 69 | |
Arjan van de Ven | 846442c | 2008-12-01 14:21:06 -0800 | [diff] [blame] | 70 | touch $T.oo |
Randy Dunlap | dcecc6c | 2007-07-15 23:41:15 -0700 | [diff] [blame] | 71 | if [ $marker -ne 0 ]; then |
Arjan van de Ven | 846442c | 2008-12-01 14:21:06 -0800 | [diff] [blame] | 72 | echo All code >> $T.oo |
| 73 | echo ======== >> $T.oo |
| 74 | beforemark=`echo "$code"` |
Rabin Vincent | 5358db0 | 2010-01-05 20:27:58 +0530 | [diff] [blame] | 75 | echo -n " .$type 0x" > $T.s |
| 76 | echo $beforemark | sed -e 's/ /,0x/g; s/[<>()]//g' >> $T.s |
| 77 | disas $T |
| 78 | cat $T.dis >> $T.oo |
| 79 | rm -f $T.o $T.s $T.dis |
Randy Dunlap | dcecc6c | 2007-07-15 23:41:15 -0700 | [diff] [blame] | 80 | |
| 81 | # and fix code at-and-after marker |
| 82 | code=`echo "$code" | cut -c$((${marker} + 1))-` |
| 83 | fi |
Arjan van de Ven | 846442c | 2008-12-01 14:21:06 -0800 | [diff] [blame] | 84 | echo Code starting with the faulting instruction > $T.aa |
| 85 | echo =========================================== >> $T.aa |
Rabin Vincent | 5358db0 | 2010-01-05 20:27:58 +0530 | [diff] [blame] | 86 | code=`echo $code | sed -e 's/ [<(]/ /;s/[>)] / /;s/ /,0x/g; s/[>)]$//'` |
| 87 | echo -n " .$type 0x" > $T.s |
Randy Dunlap | dcecc6c | 2007-07-15 23:41:15 -0700 | [diff] [blame] | 88 | echo $code >> $T.s |
Rabin Vincent | 5358db0 | 2010-01-05 20:27:58 +0530 | [diff] [blame] | 89 | disas $T |
| 90 | cat $T.dis >> $T.aa |
Arjan van de Ven | 846442c | 2008-12-01 14:21:06 -0800 | [diff] [blame] | 91 | |
Borislav Petkov | 18ff44b | 2013-04-29 15:05:54 -0700 | [diff] [blame] | 92 | # (lines of whole $T.oo) - (lines of $T.aa, i.e. "Code starting") + 3, |
| 93 | # i.e. the title + the "===..=" line (sed is counting from 1, 0 address is |
| 94 | # special) |
| 95 | faultlinenum=$(( $(wc -l $T.oo | cut -d" " -f1) - \ |
| 96 | $(wc -l $T.aa | cut -d" " -f1) + 3)) |
| 97 | |
Borislav Petkov | 2a95e37 | 2012-08-15 13:00:51 +0200 | [diff] [blame] | 98 | faultline=`cat $T.dis | head -1 | cut -d":" -f2-` |
Rabin Vincent | 5358db0 | 2010-01-05 20:27:58 +0530 | [diff] [blame] | 99 | faultline=`echo "$faultline" | sed -e 's/\[/\\\[/g; s/\]/\\\]/g'` |
Arjan van de Ven | 846442c | 2008-12-01 14:21:06 -0800 | [diff] [blame] | 100 | |
Borislav Petkov | 18ff44b | 2013-04-29 15:05:54 -0700 | [diff] [blame] | 101 | cat $T.oo | sed -e "${faultlinenum}s/^\(.*:\)\(.*\)/\1\*\2\t\t<-- trapping instruction/" |
Arjan van de Ven | 846442c | 2008-12-01 14:21:06 -0800 | [diff] [blame] | 102 | echo |
| 103 | cat $T.aa |
| 104 | cleanup |